 
/**
 * @author Lenidas de Oliveira Brando
 * @see    ScrollApplet.java; FrameFecha.java
 *
 * MAC323 - 2003
 * Exemplo simples para definir cores pelo sistema RGB ('R': red; 'G': green; 'B': blue)
 * Usa "Scrollbar" (barra deslizante) e tambm varivel "booleana" para testar tcnica de "double buffering"
 *
 * Teste para definio de cores: soluo 1
 *
 * FrameFecha  : sub-classe de "Frame", para permitir "matar" janela clicando-se no "X"
 * ScrollApplet: para abrir um "Frame" a partir de um "applet" (mas como uso "dispose" no Frame que def. aqui d erro...)
 */

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;

import java.awt.BorderLayout;
import java.awt.Font;

import java.util.StringTokenizer;

public class ScrollCores extends FrameFecha { //

  private static int limiteScroll = 1000;
  private static int maxInt       = 255;
  private static int maxCor       = 256; // cor vai de 0 at 255
  private static int tamBotao     =  50;

  private Image offscreen = null;  // para tcnica de DOUBLE BUFFERING evita "flicker" e aqui consegue-se
  private boolean doubleBuffering = true; // para testar "double buffering"

  int corVerm = maxCor, corVerde = maxCor, corAzul = maxCor;
  int alturaPainel = 100, larguraPainel = 400;

  Label labelCores = new Label("Cores");
  Color corLabel   = Color.black;

  JanelaScroll painelCores = new JanelaScroll() ;
  Janela janelaCores = new Janela();

  public ScrollCores () {
    }

  void montaJanelaScroll () {
    setLayout(new BorderLayout());

    painelCores.setSize(larguraPainel,alturaPainel);

    //janelaCores.setSize(this.getSize().width/3, this.getSize().height/3);
    janelaCores.setVisible(true);
    //janelaCores.repaint();
    //repaint();

    add(janelaCores); //,BorderLayout.WEST); //); //,"West");//);
    add(painelCores,BorderLayout.EAST); //,"East");
    }

  public static void main(String[] args) {
    ScrollCores f = new ScrollCores();//Frame();//
    f.montaJanelaScroll();
    f.setSize(400,200);
    f.setVisible(true);
    }

  class JanelaScroll extends Panel implements AdjustmentListener {
    Color cor;

    public Scrollbar scrollerVermelho  = new Scrollbar(Scrollbar.HORIZONTAL, 0, 0, 0, maxCor), //
                     scrollerVerde     = new Scrollbar(Scrollbar.HORIZONTAL, 0, 0, 0, maxCor), //
                     scrollerAzul      = new Scrollbar(Scrollbar.HORIZONTAL, 0, 0, 0, maxCor); //
    Label rotuloR = new Label("Vermelho       "),
          rotuloG = new Label("Verde          "),
          rotuloB = new Label("Azul           ");

    Panel painelS = new Panel();

    private void defineCores () {
      int c;
      c = scrollerVermelho.getValue(); corVerm  = c; rotuloR.setText("Vermelho: "+c);
      c = scrollerVerde.getValue(); corVerde = c; rotuloG.setText("Verde:    "+c);
      c = scrollerAzul.getValue(); corAzul  = c; rotuloB.setText("Azul:     "+c);
      corLabel = new Color(corVerm, corVerde, corAzul);
      }

    public void adjustmentValueChanged(AdjustmentEvent evt) {
      //System.out.println(((Object)evt.getAdjustable()).getClass()+" | "+str); // 
      defineCores();
      janelaCores.pinta(); // 
      }
     

    JanelaScroll () {
      rotuloR.setBackground(Color.red);   rotuloR.setFont(new Font("Arial", Font.BOLD, 10));
      rotuloG.setBackground(Color.green); rotuloG.setFont(new Font("Arial", Font.BOLD, 10));
      rotuloB.setBackground(Color.blue);  rotuloB.setFont(new Font("Arial", Font.BOLD, 10));

      defineCores();

     
      painelS.setLayout(new GridLayout(3,2)); //(new BorderLayout()); NO funciona aqui

      painelS.add(rotuloR); painelS.add(scrollerVermelho);
      painelS.add(rotuloG); painelS.add(scrollerVerde);
      painelS.add(rotuloB); painelS.add(scrollerAzul);

      scrollerVermelho.setValue(maxCor); scrollerVerde.setValue(maxCor); scrollerAzul.setValue(maxCor);
      scrollerVermelho.setBlockIncrement(maxCor/10); scrollerVerde.setBlockIncrement(maxCor/10); 
      scrollerAzul.setBlockIncrement(maxCor/10);

      scrollerVermelho.addAdjustmentListener(this); scrollerVerde.addAdjustmentListener(this); 
      scrollerAzul.addAdjustmentListener(this);
      painelS.setVisible(true);

      this.setLayout(new GridLayout(2,1)); //
      this.add(labelCores); //
      this.add(painelS);    //
      this.setVisible(true);
      }
    } // class JanelaScroll


  class Janela extends Panel { //
    int altura  = 140; //(int) this.getSize().height;
    int largura = 140; //(int) this.getSize().width; 
    int bordo   =  15;

    Janela () {
      this.setVisible(true);
      painelCores.defineCores();
      }

   // Chamado sempre que precisa atualizar desenho
   public void pinta() {
     if (doubleBuffering) {
        Dimension d = new Dimension(largura,altura); //
        Graphics g=offscreen.getGraphics(); // copia tudo de uma vez para a tela
        paint(g); // pinta tudo: nesta posio conseguimos fazer uma pintura para cada chamada 
        }
     // se trocar cdigo acima por mero "repaint();", o "flicker" continuar
     else repaint();
     }

    public void paint(Graphics g) {
      this.setSize(largura,altura);

      if (doubleBuffering) { // Double buffering
         if (offscreen == null) // primeiro "paint" entra antes de construir primeira "offscreen"
            offscreen = this.createImage(largura, altura); // precisa ser construido dentro do "paint"
         g = offscreen.getGraphics(); // pega ltimo buffer "grfico"
         }

      //labelCores.setBackground(corLabel); // se quiser alterar o fundo do rtulo
      labelCores.setForeground(corLabel);
      g.setColor(Color.black);
      g.drawRect(bordo-1, bordo-1, largura-bordo-1, altura-bordo); //
      g.setColor(new Color(corVerm, corVerde, corAzul)); //

      g.fillRect(bordo, bordo, largura-bordo-2, altura-bordo-2); //

      if (doubleBuffering) { // Double buffering
         g = this.getGraphics();
         g.drawImage(offscreen,0,0,this);
         }

     }
    } // class Janela

  }
